require 'nokogiri'
require 'ginspider/http'

module Ginspider

  class Analysis

    # 
    # return nokogiri response
    # 
    def self.noko_res(url)
      res_body = get_res_body(url)
      noko_res = get_noko_res(res_body)
      return noko_res
    end

    # 
    # return links of response with url and options
    # 
    def self.res_links(url, options = {})
      res_body = get_res_body(url)
      res_links = get_res_links(res_body, options)
      return res_links
    end

    # 
    # return text of response with url and options
    # 
    def self.res_text(url, options = {})
      res_body = get_res_body(url)
      res_text = get_res_text(res_body, options)
      return res_text
    end
    
    private

    # 
    # get the response body
    # 
    def self.get_res_body(url)
      @res_body = Http.res_body(url)
      return @res_body
    end

    # 
    # generate a nokogiri response
    # 
    def self.get_noko_res(res_body)
      @noko_res = Nokogiri::HTML(res_body.to_s)
      return @noko_res
    end

    # 
    # get all the links from nokogiri object
    # 
    def self.get_res_links(res_body, options = {})
      @noko_res = get_noko_res(res_body)
      @noko_targets = @noko_res.css(options["element"])

      links = []
      i = 0
      @noko_targets.each do |link|
        links[i] = link["href"].strip
        i = i + 1
      end

      return links
    end

    # 
    # get all the text from nokogiri object
    # 
    def self.get_res_text(res_body, options = {})
      @noko_res = get_noko_res(res_body)
      @noko_target = @noko_res.css(options["element"])
      text = @noko_target.text

      return text
    end

  end

end